SystemOrganization addCategory: #'Deltawerken-Base'!
SystemOrganization addCategory: #'Deltawerken-Base-User'!
SystemOrganization addCategory: #'Deltawerken-Base-Announcements'!

Announcement subclass: #DEExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base-Announcements'!

!DEExpired commentStamp: 'DiegoLont 4/11/2012 13:10' prior: 0!
DEExpired is announced if a page is displayed of an expired session!

Announcement subclass: #DEGoHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base-Announcements'!

!DEGoHome commentStamp: 'DiegoLont 4/11/2012 13:11' prior: 0!
DEGoHome is used to indicate to go back to the main page!

Announcement subclass: #DELoggedIn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base-Announcements'!

!DELoggedIn commentStamp: 'DiegoLont 4/11/2012 13:11' prior: 0!
DELoggedIn is announced if a user logs on!

Announcement subclass: #DELoggedOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base-Announcements'!

!DELoggedOut commentStamp: 'DiegoLont 4/11/2012 13:11' prior: 0!
DELoggedOut is announced if a user logs off!

WAComponent subclass: #DEComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base'!

!DEComponent commentStamp: 'DiegoLont 4/11/2012 13:04' prior: 0!
DEComponent is a base component, that can access an announcer and user functionality. !

!DEComponent methodsFor: 'session' stamp: 'DiegoLont 8/26/2012 10:41'!
announce: anAnnouncement
	self session announce: anAnnouncement! !

!DEComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
announcer
	^self session announcer! !

!DEComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
announcer: anAnnouncer
	self session announcer: anAnnouncer! !

!DEComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
ifLoggedIn: aBlock
	self isLoggedIn ifTrue: [ aBlock value ]
! !

!DEComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
isLoggedIn
	^self session isLoggedIn! !

!DEComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
newAnnouncerUntil: anAnnouncement
	| oldAnnouncer |
	oldAnnouncer := self announcer.
	self resetAnnouncer.
	self announcer
		subscribe: anAnnouncement
		do: [ :ann | 
			self announcer: oldAnnouncer.
			self announce: ann ]
		for: self
	! !

!DEComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
resetAnnouncer
	self session resetAnnouncer! !

!DEComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
user
	^self session user! !

!DEComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
user: aUser
	self session user: aUser! !

!DEComponent methodsFor: 'session' stamp: 'DiegoLont 8/22/2011 17:27'!
username
	^self session username! !

DEComponent subclass: #DELoginForm
	instanceVariableNames: 'editComponent userClass welcomeText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base'!

!DELoginForm commentStamp: 'DiegoLont 4/11/2012 13:04' prior: 0!
DELoginForm is a default component to provide a login box. It can be configured in css.!

!DELoginForm methodsFor: 'hooks' stamp: 'DiegoLont 2/14/2012 14:36'!
children
	^Array with: self editComponent! !

!DELoginForm methodsFor: 'initialization' stamp: 'DiegoLont 2/14/2012 14:52'!
createEditComponent
	^DEEditComponent new
		title: self welcomeText;
		subject: self userClass new isNew: true;
		propertySymbol: #loginFields;
		hasValidation: false;
		yourself! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 15:07'!
editComponent
	^editComponent ifNil: [ editComponent := self createEditComponent ]! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 17:27'!
invalidCombinationText
	^ 'Invalid combination of userid and password.'! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 17:25'!
loggedInText
	^ 'Logged in as ' , self username! !

!DELoginForm methodsFor: 'navigation' stamp: 'DiegoLont 2/14/2012 15:13'!
login
	| user |
	user := (self userClass)
		userWithId: self loginid
		passwordHash: self passwordHash.
	self user: user.
	user
		ifNil: [ self editComponent title: self invalidCombinationText ]
		ifNotNil: [ editComponent := nil ]! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:38'!
loginid
	^self editComponent subject userid! !

!DELoginForm methodsFor: 'navigation' stamp: 'DiegoLont 2/14/2012 15:10'!
logout
	self user: nil.
	editComponent := nil! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/20/2011 10:59'!
logoutButtonText
	^'Logout'! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 15:13'!
passwordHash
	^self editComponent subject passwordHash! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/20/2011 10:39'!
passwordLabel
	^self userClass passwordField label! !

!DELoginForm methodsFor: 'rendering' stamp: 'DiegoLont 2/14/2012 14:36'!
renderComponentOn: canvas
	canvas render: self editComponent! !

!DELoginForm methodsFor: 'rendering' stamp: 'DiegoLont 2/14/2012 14:44'!
renderContentOn: canvas 
	canvas form
		id: 'loginForm';
		class: 'loginForm';
		class: (self session isLoggedIn asString);
		with: [
			self session isLoggedIn ifFalse: [
					self
						renderComponentOn: canvas;
						renderLoginOn: canvas;
						yourself ]
				ifTrue: [
					self
						renderTitleOn: canvas;
						renderLogoutOn: canvas;
						yourself ] ]! !

!DELoginForm methodsFor: 'rendering' stamp: 'DiegoLont 2/14/2012 14:30'!
renderLoginOn: canvas
	canvas div: [
		canvas submitButton
			callback: [self login];
			with: 'Login' ]! !

!DELoginForm methodsFor: 'rendering' stamp: 'DiegoLont 12/20/2011 10:59'!
renderLogoutOn: canvas

	canvas div: [
		canvas submitButton
			callback: [self logout];
			with: self logoutButtonText.
	].! !

!DELoginForm methodsFor: 'rendering' stamp: 'DiegoLont 12/21/2011 11:59'!
renderTableOn: canvas 
	canvas table: [
		self 
			renderUserOn: canvas;
			renderPasswordOn: canvas ].
	canvas horizontalRule! !

!DELoginForm methodsFor: 'rendering' stamp: 'DiegoLont 2/14/2012 15:09'!
renderTitleOn: canvas
	canvas div
		class: 'title';
		with: [
			canvas heading
				level: 2;
				with: self loggedInText ]! !

!DELoginForm methodsFor: 'hooks' stamp: 'DiegoLont 2/14/2012 14:37'!
states
	^Array with: self! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 15:22'!
title
	self session isLoggedIn ifTrue: [ ^ self loggedInText ].
	(self userid isNil or: [ self userid isEmpty ]) ifTrue: [ ^self welcomeText ].
	^ self invalidCombinationText! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 15:23'!
userClass
	userClass ifNil: [ ^DEUser ].
	^userClass
! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 15:23'!
userClass: aClass
	userClass := aClass! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 15:22'!
userid
	^self editComponent subject userid! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/20/2011 10:39'!
useridLabel
	^self userClass useridField label! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 15:24'!
welcomeText
	welcomeText ifNil: [ ^'Please enter username and password' ].
	^welcomeText! !

!DELoginForm methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 15:25'!
welcomeText: anObject
	welcomeText := anObject! !

DEComponent subclass: #DEPageChoice
	instanceVariableNames: 'pages currentPage homepage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base'!

!DEPageChoice commentStamp: 'DiegoLont 4/11/2012 13:07' prior: 0!
DEPageChoice is a tab component, that displays one page at a time. It uses announcements to switch pages, to decouple it from the trigger to change pages.!

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
addPage: page
	self pages 
		detect: [ :each | each = page ]
		ifNone: [ self pages add: page ].
	currentPage ifNil: [ currentPage := page ].
	^page! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 9/10/2012 12:55'!
addPage: page announcement: announcement
	self addPage: page.
	self announcer
		on: announcement
		do: [ :ann | 
			self currentPage: page.
		]
! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 14:03'!
addPage: page announcement: announcement subject: subject accessors: accessors
	self addPage: page.
	self announcer
		subscribe: announcement
		do: [ :ann |
			| temp |
			temp := subject.
			accessors do: [ :each| temp := temp perform: each ].
			page subject: temp.
			self currentPage: page.
		]
		for: self
! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 9/10/2012 12:55'!
addPage: page announcement: announcement symbol: aSymbol
	self addPage: page.
	self announcer
		on: announcement
		do: [ :ann |
			(ann perform: aSymbol) ifNotNil: [ page subject: (ann perform: aSymbol) ].
			self currentPage: page]
! !

!DEPageChoice methodsFor: 'hooks' stamp: 'StephanEggermont 4/29/2011 00:19'!
children
	^self pages
! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
currentPage
	^currentPage ifNil: [ currentPage := self homepage ]! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
currentPage: aPage
	currentPage := aPage! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
goHome
	self currentPage: homepage! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 9/10/2012 12:55'!
goHomeOn: announcement 
	self announcer 
		on: announcement
		do: [ :ann | self currentPage: homepage ]! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
homepage
	homepage ifNil: 
		[ self pages ifEmpty: [ ^ nil ].
		^ self pages first ].
	^ homepage! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
homepage: aPage 
	self addPage: aPage.
	homepage := aPage! !

!DEPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
pages
	^pages ifNil: [ pages := OrderedCollection new ]
! !

!DEPageChoice methodsFor: 'rendering' stamp: 'DiegoLont 12/19/2011 16:39'!
renderContentOn: canvas
	currentPage 
		ifNil:  [ canvas text: 'Internal error in ', self class name ,': no current page set.' ]
		ifNotNil: [ canvas render: currentPage ]! !

!DEPageChoice methodsFor: 'hooks' stamp: 'StephanEggermont 5/20/2011 15:56'!
states
	^Array with: self
! !

WASession subclass: #DESession
	instanceVariableNames: 'user announcer locale defaultTimeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base'!

!DESession commentStamp: 'DiegoLont 4/11/2012 13:10' prior: 0!
DESession is a session object that contains user data and an announcer. It allows to announce things along the session!

!DESession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
announce: anAnnouncement
	self announcer announce: anAnnouncement
! !

!DESession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
announcer
	^announcer ifNil: [ announcer := Announcer new ]
! !

!DESession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
announcer: anAnnouncer
	announcer := anAnnouncer
! !

!DESession methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 10:57'!
defaultTimeout
	^defaultTimeout! !

!DESession methodsFor: 'security' stamp: 'StephanEggermont 4/29/2011 00:23'!
isLoggedIn
	user ifNotNil: [ ^ true ].
	^ false! !

!DESession methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:52'!
loginAnnouncement
	^DELoggedIn! !

!DESession methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 15:52'!
loginAnnouncementFor: aUser
	^self loginAnnouncement! !

!DESession methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 10:58'!
loginTimeout
	^nil! !

!DESession methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:53'!
logoutAnnouncement
	^DELoggedOut! !

!DESession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
resetAnnouncer
	announcer := nil
! !

!DESession methodsFor: 'accessing' stamp: 'DiegoLont 4/11/2012 10:55'!
setTimeout
	self shouldBeImplemented.! !

!DESession methodsFor: 'navigation' stamp: 'StephanEggermont 9/3/2012 23:15'!
setTimeout: aValue 
	aValue ifNotNil: [ 
		defaultTimeout := self parent cache expiryPolicy configuration at: #cacheTimeout.
		self parent cache expiryPolicy configuration at: #cacheTimeout put: aValue ]! !

!DESession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
user
	^ user! !

!DESession methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 15:52'!
user: anObject
	(user ~= anObject) ifTrue: [
		user := anObject.
		user ifNil: [
			self setTimeout: self defaultTimeout.
			self announcer announce: self logoutAnnouncement ]
		ifNotNil: [
			self setTimeout: self loginTimeout.
			self announcer announce: (self loginAnnouncementFor: user) ] ]! !

!DESession methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 16:41'!
username
	user ifNil: [
		^'No user logged in.'
	].
	^ user username! !

Object subclass: #DEDomainObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base'!

!DEDomainObject commentStamp: 'DiegoLont 4/11/2012 13:09' prior: 0!
DEDomainObject is a base class for domain objects. It provides default functionality for most domain objects, like implementation of fields, editfields and such. One does not require to use this class, but one needs to implement the methods of this class.!

!DEDomainObject class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:27'!
cardFields
	^self editFields! !

!DEDomainObject class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:27'!
editFields
	^self fields! !

!DEDomainObject class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:27'!
fields
	^#()! !

!DEDomainObject class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:27'!
searchFields
	^self fields! !

!DEDomainObject methodsFor: 'fields' stamp: 'DiegoLont 3/12/2012 12:11'!
editFields
	^self class editFields! !

!DEDomainObject methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:34'!
hasMatch: aSearchValue fields: aFieldCollection
	aFieldCollection do: [ :each |
		(each find: aSearchValue in: self) ifTrue: [ ^true ] ].
	^false! !

!DEDomainObject methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:34'!
hasMatchDetailed: aDictionary fields: aFieldCollection
	aFieldCollection do: [ :each |
		| searchValue |
		searchValue := aDictionary at: each.
		(each isValidValue: searchValue) 
			ifTrue: [ (each find: searchValue in: self) ifFalse: [ ^false ] ] ].
	^true! !

!DEDomainObject methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:27'!
saveData: aDomainObject
	self saveData: aDomainObject fieldsAccessor: #editFields! !

!DEDomainObject methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:35'!
saveData: aDomainObject fields: aFieldCollection
	aDomainObject ifNotNil: [
		aFieldCollection do: [ :field |
			field readonly ifFalse: [ field save: (field value: aDomainObject) in: self ] ] ]! !

!DEDomainObject methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 21:53'!
saveData: aDomainObject fieldsAccessor: anAccessor
	aDomainObject ifNotNil: [
		| domainClass |
		domainClass := aDomainObject class.
		self
			saveData: aDomainObject
			fields: ((domainClass perform: anAccessor) collect: [ :each | domainClass perform: each ]) ]! !

!DEDomainObject methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:27'!
updateWith: aDomainObject
	self updateWith: aDomainObject fields: self class editFields! !

!DEDomainObject methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:35'!
updateWith: aDomainObject fields: aFieldCollection
	aFieldCollection do: [ :each |
		| field |
		field := self class perform: each.
		field setValue: (field value: aDomainObject) of: self ]! !

DEDomainObject subclass: #DEUser
	instanceVariableNames: 'userid passwordHash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base-User'!

!DEUser commentStamp: 'DiegoLont 8/21/2011 14:45' prior: 0!
DEUser is an abstract class for a user. It provides basic functionality for a userid / password combination and password validation.

Subclasses should override the users method (class side)!

!DEUser class methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 15:31'!
addUser: aUser
	^self users add: aUser! !

!DEUser class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:18'!
fields
	^#( #usernameField #passwordField )! !

!DEUser class methodsFor: 'fields' stamp: 'DiegoLont 12/20/2011 10:41'!
initialEditFields
	^#( useridField passwordField )! !

!DEUser class methodsFor: 'testing' stamp: 'DiegoLont 1/3/2012 13:09'!
isValidUserid: aValue
	aValue ifNil: [ ^false ].
	aValue ifEmpty: [ ^false ].
	(self userWithId: aValue) ifNotNil: [ ^false ].
	^true! !

!DEUser class methodsFor: 'testing' stamp: 'DiegoLont 1/3/2012 13:09'!
isValidUseridError: aValue
	aValue ifNil: [ ^'Username should not be empty' ].
	aValue ifEmpty: [ ^'Username should not be empty' ].
	(self userWithId: aValue) ifNotNil: [ ^'There already is a user with name ', aValue ].
	^''! !

!DEUser class methodsFor: 'fields' stamp: 'DiegoLont 2/14/2012 14:35'!
loginFields
	^#( #useridField #passwordField )! !

!DEUser class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:41'!
passwordField
	^DEPasswordField new
		label: 'Password';
		accessor: #( #password );
		required: true;
		yourself! !

!DEUser class methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:47'!
userWithId: idString
	| lowercaseIdString |
	idString ifNil: [ ^nil ].
	lowercaseIdString := idString asLowercase.
	^self users
		detect: [:each | each notNil and: [ each userid = lowercaseIdString ] ]
		ifNone: [nil].! !

!DEUser class methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:46'!
userWithId: idString password: passwordString
	| user |
	user := self userWithId: idString.
	user ifNil: [ ^nil ].
	(user verifyPassword: passwordString)
		ifTrue: [ 
			user rightPassword.
			^user ]
		ifFalse: [
			user wrongPassword.
			^nil ]
! !

!DEUser class methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 15:12'!
userWithId: idString passwordHash: passwordHash
	| user |
	user := self userWithId: idString.
	user ifNil: [ ^nil ].
	(user verifyPasswordHash: passwordHash)
		ifTrue: [ 
			user rightPassword.
			^user ]
		ifFalse: [
			user wrongPassword.
			^nil ]
! !

!DEUser class methodsFor: 'fields' stamp: 'DiegoLont 2/14/2012 14:35'!
useridField
	^DEStringField new
		label: 'Username';
		accessor: #( #userid );
		validator: (DECustomValidator new
			required: true;
			validateBlock: [ :value | self isValidUserid: value ];
			errorBlock: [ :value | self isValidUseridError: value ];
			yourself);
		yourself! !

!DEUser class methodsFor: 'fields' stamp: 'DiegoLont 2/14/2012 14:35'!
usernameField
	^DEStringField new
		beReadonly;
		accessor: #( #username );
		yourself! !

!DEUser class methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:43'!
users
	^self subclassResponsibility.! !

!DEUser methodsFor: 'security' stamp: 'DiegoLont 8/21/2011 14:31'!
hashPassword: aString
	^GRPlatform current secureHashFor: aString ! !

!DEUser methodsFor: 'accessing' stamp: 'DiegoLont 12/20/2011 10:56'!
password
	passwordHash ifNil: [ ^nil ].
	^'***'! !

!DEUser methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 21:31'!
password: anObject
	passwordHash := self hashPassword: anObject! !

!DEUser methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:23'!
passwordHash
	passwordHash ifNil: [ ^'' ].
	^ passwordHash! !

!DEUser methodsFor: 'security' stamp: 'DiegoLont 8/21/2011 14:22'!
rightPassword
	" default no security "! !

!DEUser methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:46'!
userid
	" the userid needs to be unique "
	^ userid! !

!DEUser methodsFor: 'accessing' stamp: 'DiegoLont 3/12/2012 12:20'!
userid: anObject
	userid := anObject asLowercase! !

!DEUser methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:36'!
username
	" the display name for a user, need not be unique "
	self userid ifNil: [ ^'' ].
	^self userid! !

!DEUser methodsFor: 'security' stamp: 'DiegoLont 8/22/2011 21:33'!
verifyPassword: aString
	^(self hashPassword: aString) = self passwordHash.! !

!DEUser methodsFor: 'security' stamp: 'DiegoLont 2/14/2012 15:14'!
verifyPasswordHash: aHash
	^aHash = self passwordHash.! !

!DEUser methodsFor: 'security' stamp: 'DiegoLont 8/21/2011 14:18'!
wrongPassword
	" default no security "! !

DEDomainObject subclass: #DEUserPassword
	instanceVariableNames: 'user password passwordVerify'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Base-User'!

!DEUserPassword commentStamp: 'DiegoLont 8/21/2011 14:51' prior: 0!
DEUserPassword is a domain object that helps with the presentation of a password change. It stores a reference to the user and allows the entry of both a password and a verification.!

!DEUserPassword class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:47'!
fields
	^#( #usernameField #passwordField #passwordVerifyField )! !

!DEUserPassword class methodsFor: 'instance creation' stamp: 'DiegoLont 8/21/2011 14:47'!
on: aUser
	^self basicNew
		initialize: aUser;
		yourself! !

!DEUserPassword class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:49'!
passwordField
	^DEPasswordField new
		label: 'password';
		accessor: #( #password );
		required: true;
		validator: (DEStringValidator new
			required: true;
			errorMessage: 'Password is required.';
			yourself)
		yourself! !

!DEUserPassword class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:49'!
passwordVerifyField
	^DEPasswordField new
		label: 'password verification';
		accessor: #( #passwordVerify );
		validator: (DECustomValidator new
			required: true;
			validateBlock: [ :subject :value | subject password = value ];
			errorBlock: [ :value | 'Passwords should be equal.' ];
			yourself);
		yourself! !

!DEUserPassword class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 14:49'!
usernameField
	^DEUser usernameField
		addToAccessor: #( #user );
		yourself! !

!DEUserPassword methodsFor: 'initialization' stamp: 'DiegoLont 8/21/2011 14:47'!
initialize: aUser
	self initialize.
	user := aUser! !

!DEUserPassword methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:47'!
password
	^ password! !

!DEUserPassword methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:47'!
password: anObject
	password := anObject! !

!DEUserPassword methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:47'!
passwordVerify
	^ passwordVerify! !

!DEUserPassword methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:47'!
passwordVerify: anObject
	passwordVerify := anObject! !

!DEUserPassword methodsFor: 'accessing' stamp: 'DiegoLont 8/21/2011 14:47'!
user
	^user! !
